package com.mingxue.spider.fliphtml5;

import java.io.File;
import java.io.IOException;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;

import cn.hutool.core.lang.Dict;
import cn.hutool.core.lang.UUID;
import okhttp3.FormBody;
import okhttp3.MediaType;
import okhttp3.MultipartBody;
import okhttp3.MultipartBody.Builder;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;

public class QuickUpload {
    private static String host = "https://fliphtml5.com";
    private OkHttpClient.Builder builder;
    private Request.Builder requestBuilder;
    private OkHttpClient okHttpClient;
    private User user = new User();

    class User {
        String mail = "duzejun111@163.com";
        String pass = "duzejun";
        String name;
        String cId;
        String uId;

    }

    private QuickUpload() {
        builder = new OkHttpClient.Builder();
        okHttpClient = builder.build();
        requestBuilder = new Request.Builder();// 省的每次都new request操作,直接builder出来,随后需要什么往里加,build出来即可
    }

    public void login() {
        try {
            httpGetHtml("/login.php");
            // umail=duzejun111%40163.com&upass=duzejun&isMobile=0
            Dict data = Dict.create().set("umail", user.mail).set("upass", user.pass).set("isMobile", 0);
            String res = httpPost("/userLoad/handle-user-log-in.php", data);
            // {"status":"1","cId":"3173336","uId":"2953511","uLink":"hsucl","uName":"duzejun111","PrimaryAccountId":"0","uType":"0","mess":""}
            JSONObject json = JSON.parseObject(res);
            user.cId = json.getString("cId");
            user.uId = json.getString("uId");
            user.name = json.getString("uName");
        } catch (Exception e) {
            // TODO: handle exception
        }
    }

    public void upload(String path) {
        try {
            String url = "https://s3.amazonaws.com/online.fliphtml5.com";
            Builder builder = new MultipartBody.Builder();
            File file = new File(path);
            builder.addFormDataPart("file", file.getName(), MultipartBody.create(MediaType.parse("multipart/form-data"), file));
            httpPost(url, builder.build());
        } catch (Exception e) {
            // TODO: handle exception
        }
    }

    public String httpGetHtml(String url) throws IOException {
        Request request = requestBuilder.url(host + url).build();
        Response res = okHttpClient.newCall(request).execute();
        return res.body().string();
    }

    public String httpPost(String url, Dict data) throws IOException {
        FormBody.Builder builder = new FormBody.Builder();
        for (String key : data.keySet()) {
            builder.add(key, data.getStr(key));
        }
        return httpPost(host + url, builder.build());
    }

    public String httpPost(String url, RequestBody body) throws IOException {
        Request request = requestBuilder.url(url).method("POST", body).build();
        Response res = okHttpClient.newCall(request).execute();
        return res.body().string();
    }

    public static void main(String[] args) {
        QuickUpload qu = new QuickUpload();
        qu.login();
        qu.upload("e:/temp/Java编码规范.pdf");

    }
}
