package com.mingxue.spider.jlzy;

import java.util.HashMap;
import java.util.Map;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.mingxue.spider.helper.StringUtils;

@SuppressWarnings("serial")
public class Abstractservice {
    protected Logger log = LoggerFactory.getLogger(getClass());
    protected static String host = "https://apiv4.diyigaokao.com";
    // 字体编码
    static Map<Integer, String> fontMap = new HashMap<Integer, String>() {
        {
            put(1, "0923546781");
            put(2, "0329547681");
            put(3, "0359247681");
            put(4, "0351426789");
        }
    };

    /**
     * 数据解密
     * 
     * @param row
     * @param thData
     */
    protected void decrypt(JSONObject row, Integer fontId, JSONArray thData) {
        // 解密错位数据
        for (int i = 0; i < thData.size(); i++) {
            JSONObject th = thData.getJSONObject(i);
            if (th.getInteger("encryption") == 1) {
                String prop = th.getString("prop");
                String originalValue = row.getString(prop);
                if (StringUtils.isNotBlank(originalValue)) {
                    String realValue = getRealData(fontId, originalValue);
                    row.put(prop, realValue);
                }
            }
        }
    }

    protected String getRealData(Integer fontId, String data) {
        if (StringUtils.isBlank(data)) {
            return data;
        }
        StringBuilder result = new StringBuilder();
        for (char index : data.toCharArray()) {
            result.append(fontMap.get(fontId).toCharArray()[Integer.parseInt(String.valueOf(index))]);
        }
        return result.toString();
    }
}
