package com.mingxue.spider.jlzy;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.mingxue.spider.utils.ApiUtil;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.thread.ThreadUtil;
import cn.hutool.db.DbUtil;
import cn.hutool.db.Entity;

public class CollegeService extends Abstractservice {

    /**
     * 获取学校信息
     */
    public void list() {

    }

    /**
     * 院校录取数据 2021
     */

    /**
     * 专业录取数据 2021
     */

    /**
     * 招生计划数据 2022
     * 
     * @param collegeId
     * @param Location
     * @param ProvinceId
     * @throws SQLException
     */
    public void plan() throws SQLException {
        List<Entity> list = DbUtil.use().find(Arrays.asList("id", "collegeCodeGb", "provinceId"), Entity.create());
        ApiUtil.getInstance().login();
        for (Entity row : list) {
            Integer collegeId = row.getInt("id");
            plan(collegeId);
        }

    }

    private void plan(Integer collegeId) {
        long start = System.currentTimeMillis();
        ThreadUtil.safeSleep(2 * 1000);
        Integer year = 2022;
        final String tableName = "sy_colledge_recruit_data_" + year;
        try {
            // 科类： 1理科(物理)，0文科(历史)
            List<Integer> liberalScienceList = Arrays.asList(0, 1);
            List<Entity> entityList = new ArrayList<>();
            for (Integer liberalScience : liberalScienceList) {
                try {
                    StringBuilder sb = new StringBuilder(host);
                    sb.append("/query/majorPlan/byCollege");
                    sb.append("?collegeId=").append(collegeId);
                    sb.append("&liberalScience=").append(liberalScience);
                    sb.append("&year=").append(year);
                    sb.append("&pageIndex=").append(1);
                    sb.append("&pageSize=").append(100);
                    JSONObject res = ApiUtil.getInstance().httpSyncGet(sb.toString());
                    if (res.getInteger("error") == 0) {
                        JSONObject data = res.getJSONObject("data");
                        JSONArray tdData = data.getJSONArray("tdData");
                        JSONArray thData = data.getJSONArray("thData");
                        // font
                        Integer fontId = res.getJSONObject("font").getInteger("id");
                        String fontValue = fontMap.get(fontId);
                        for (int i = 0; i < tdData.size(); i++) {
                            JSONObject row = tdData.getJSONObject(i);
                            decrypt(row, fontId, thData);
                            row.put("Location", "湖南");// 湖南
                            row.put("font_id", fontId);
                            row.put("font_value", fontValue);
                            row.put("update_time", new Date());
                            Entity entity = Entity.create(tableName);
                            entity.putAll(row);
                            entityList.add(entity);
                        }
                    }
                } catch (Exception e) {
                    log.error(e.getMessage(), e);
                }
                if (CollectionUtil.isNotEmpty(entityList)) {
                    DbUtil.use().del(Entity.create(tableName).set("CollegeID", collegeId).set("Year", year));
                    DbUtil.use().insert(entityList);
                }
            }
        } catch (SQLException e) {
            log.error(e.getMessage(), e);
        } finally {
            log.info("获取{},{}年招生计划数用时:{}", collegeId, year, DateUtil.formatBetween(System.currentTimeMillis() - start));
        }
    }

    public static void main(String[] args) {
        ApiUtil.getInstance().login();
        new CollegeService().plan(1526);
    }

}
