package com.mingxue.spider.youzy;

import java.util.List;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import cn.hutool.core.lang.Dict;

/**
 * 分数相当服务
 * 
 * @author Duzj
 *
 */
public class ScoreService extends AbstractService {

    /**
     * @param provinceCode
     * @return
     */
    public JSONObject planConfig(Integer provinceCode) {
        String api = "/youzy.dms.datalib.api.enrolldata.plan.config.get?provinceCode=" + provinceCode;
        JSONObject res = (JSONObject)postBody(api);
        JSONArray arr = res.getJSONArray("years");
        return null != arr && arr.size() > 0 ? arr.getJSONObject(0) : null;
    }

    public void plan(Integer provinceCode, String collegeCode, Integer year) {
        JSONObject config = planConfig(provinceCode);
        if (null == config || !year.equals(config.getInteger("year"))) {
            return;
        }
        String api = "/youzy.dms.datalib.api.enrolldata.plan.encrypted.v2.query";
        List<String> courses = config.getJSONArray("course").toJavaList(String.class);
        List<String> batchs = config.getJSONArray("batch").toJavaList(String.class);
        for (String course : courses) {
            for (String batch : batchs) {
                Dict body = Dict.create().set("collegeCode", collegeCode).set("year", year);
                body.set("provinceCode", provinceCode).set("course", course).set("batch", batch);
                JSONObject res = (JSONObject)postBody(api, null, body);
                JSONArray rows = res.getJSONArray("uCodes");
                if (null == rows || rows.size() == 0) {
                    continue;
                }
                rows = JSON.parseArray(decode(rows.toJSONString()));
                System.out.println(rows);
            }
        }

    }

}
