package com.mingxue.spider.youzy;

import java.util.ArrayList;
import java.util.List;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import cn.hutool.core.date.DateUtil;
import cn.hutool.db.DbUtil;
import cn.hutool.db.Entity;

public class XuankeService extends AbstractService {
    String tableName = "major";
    public void getAll() {
        long start = System.currentTimeMillis();
        try {
            List<Entity> coll = DbUtil.use().query("select id from college");
            for (Entity entity : coll) {
                getByCollege(entity.getInt("id"));
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        logger.info("获取{}选科数据用时:{}", getProvinceId(), DateUtil.formatBetween(System.currentTimeMillis() - start));
    }

    public void getByCollege(Integer collegeId) {
        List<Integer> years = new ArrayList<Integer>(2);
        Integer provinceId = getProvinceId();
        try {
            JSONObject res = httpSyncGet("/years?provinceId=" + provinceId + "&queryType=4");
            JSONArray rows = res.getJSONArray("data");
            for (int i = 0; i < rows.size(); i++) {
                years.add(rows.getJSONObject(i).getInteger("year"));
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        List<Entity> records = new ArrayList<>(12);
        for (Integer year : years) {
            int count = 0, total = 100, page = 1;
            do {
                try {
                    StringBuilder sb = new StringBuilder();
                    sb.append("/xuanke/list/byCollegeId");
                    sb.append("?provinceId=").append(provinceId);
                    sb.append("&collegeId=").append(collegeId);
                    sb.append("&year=").append(year);
                    sb.append("&page=").append(page).append("&pageSize=30");
                    JSONObject res = httpSyncGet(sb.toString());
                    JSONArray rows = res.getJSONArray("data");
                    for (int i = 0; i < rows.size(); i++) {
                        JSONObject row = rows.getJSONObject(i);
                        row.remove("Row");
                        Entity record = Entity.create(tableName);
                        record.putAll(row);
                        record.set("_provinceId", provinceId).set("_collegeId", collegeId).set("_year", year);
                        records.add(record);
                    }
                    total = res.getInteger("total");
                    count = page * 30;
                    page += 1;
                } catch (Exception e) {
                    e.printStackTrace();
                }

            } while (count <= total);
        }
        try {
            DbUtil.use().del(Entity.create(tableName).set("CollegeID", collegeId));
            DbUtil.use().insert(records);
            // DbUtil.use()
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
